﻿using System;
using System.Diagnostics;
using System.IO;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using Microsoft.Win32;

namespace erodnet
{
    static class Program
    {
        [DllImport("shell32.dll", CharSet = CharSet.Auto)]
        internal static extern void SHChangeNotify(UInt32 wEventId, UInt32 uFlags, IntPtr dwItem1, IntPtr dwItem2);

        [DllImport("user32.dll", CharSet = CharSet.Auto, EntryPoint = "FindWindow")]
        internal static extern IntPtr FindWindow(IntPtr lpClassName, string lpWindowName);
        [DllImport("user32.dll", CharSet = CharSet.Auto, EntryPoint = "SendMessage")]
        internal static extern Int32 SendMessageSetText(IntPtr hWnd, UInt32 Msg, IntPtr wParam, string lParam);
        [DllImport("user32.dll", CharSet = CharSet.Ansi, EntryPoint = "SetForegroundWindow")]
        internal static extern bool SetForegroundWindow(IntPtr hWnd);
        [DllImport("user32.dll", CharSet = CharSet.Auto, EntryPoint = "SendMessage")]
        internal static extern IntPtr SendMessageInt32(IntPtr hWnd, UInt32 Msg, Int32 wParam, Int32 lParam);
        [DllImport("user32.dll", CharSet = CharSet.Auto, EntryPoint = "RegisterWindowMessage")]
        internal static extern UInt32 RegisterWindowMessage(string lpString);

        public const int WM_SETTEXT = 0x000C;

        /// <summary>
        /// アプリケーションのメイン エントリ ポイントです。
        /// </summary>
        [STAThread]
        static void Main()
        {
            string[] ss = System.Environment.GetCommandLineArgs();
            if ((ss.Length == 2) && (ss[1] == "/Setup"))
            {
                Application.EnableVisualStyles();
                Application.SetCompatibleTextRenderingDefault(false);
                RelateForm f = new RelateForm();
                if (f.ShowDialog() == DialogResult.OK)
                {
                    bool b = true;
                    if (f.checkBox1.Checked)
                    {
                        b = b & reg1("SystemFileAssociations\\video") &
                        reg1("avifile") & reg1("mpegfile") & reg1("asffile") & reg1("wmvfile");
                    }
                    if (f.checkBox2.Checked)
                    {
                        b = b & reg1("SystemFileAssociations\\audio") &
                        reg1("mp3file") & reg1("wmafile");
                    }
                    if (b)
                    {
                        SHChangeNotify(0x08000000, 0x1000, IntPtr.Zero, IntPtr.Zero);
                    }
                    else
                    {
                        MessageBox.Show("関連付けに失敗しました", Title.AppTitle);
                    }
                }
            }
            else
            {
                bool debugging = Debugger.IsAttached;
                IntPtr h = FindWindow(IntPtr.Zero, Title.LoadInfo());
                if ((h != IntPtr.Zero) && (!debugging))
                {
                    bool Accepted = false;
                    int i = 1;
                    string s = "";
                    while (ss.Length > i)
                    {
                        if (i > 1) s = s + " ";
                        s = s + ss[i];
                        if (System.IO.File.Exists(ss[i]))
                        {
                            SendMessageSetText(h, WM_SETTEXT, IntPtr.Zero, ss[i]);
                            Accepted = true;
                        }
                        i++;
                    }
                    if ((!Accepted) && (System.IO.File.Exists(s)))
                    {
                        SendMessageSetText(h, WM_SETTEXT, IntPtr.Zero, s);
                    }
                    SetForegroundWindow(h);

                }
                else
                {
                    Application.EnableVisualStyles();
                    Application.SetCompatibleTextRenderingDefault(false);
                    Application.Run(new MainForm());
                }
            }
        }

        static bool reg1(string extension)
        {
            try
            {
                RegistryKey regkey = Registry.ClassesRoot.CreateSubKey(extension);
                regkey = regkey.CreateSubKey("shell");
                regkey.SetValue("", Path.GetFileNameWithoutExtension(Application.ExecutablePath));
                regkey = regkey.CreateSubKey(Path.GetFileNameWithoutExtension(Application.ExecutablePath));
                regkey.SetValue("", Title.AppTitle);
                regkey = regkey.CreateSubKey("command");
                regkey.SetValue("", "\"" + Application.ExecutablePath + "\" \"%1\"");
                regkey.Close();


                return true;
            }
            catch
            {
                return false;
            }
        }
    }
}
